--
-- ReversingCamera
-- You can look back throw the left window when you are reversing with truck and trailer.
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0 - 2017-09-11 - 
-- 
ReversingCamera = {};
local ReversingCamera_directory = g_currentModDirectory;

function ReversingCamera.prerequisitesPresent(specializations)
    return true;
end;

function ReversingCamera:load(xmlFile)
	for i=1, self.numCameras do
        if self.cameras[i].isInside then
           self.internalCamera = self.cameras[i].cameraNode
        end;
    end;
	xt,yt,zt = getTranslation(self.internalCamera);
    xr,yr,zr = getRotation(self.internalCamera);
    self.camPositionX = xt;  
    self.camPositionY = yt; 
    self.camPositionZ = zt;
	self.tx=xt;
    self.ty=yt;
    self.tz=zt;
	self.rear = 0;
end;
function ReversingCamera:delete()
end;

function ReversingCamera:readStream(streamId, connection)
end;

function ReversingCamera:writeStream(streamId, connection)
end;

function ReversingCamera:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ReversingCamera:keyEvent(unicode, sym, modifier, isDown)
end;

function ReversingCamera:update(dt)
	if self:getIsActive() and self.cameras[self.camIndex].isRotatable and self.cameras[self.camIndex].isInside == true then
	if Input.isKeyPressed(Input.KEY_y) then
			self.camPositionX = self.tx;
			self.camPositionY = self.ty;
			self.camPositionZ = self.tz;
	end;
	local math_pi_double  = math.pi*2
	local math_pi_half    = math.pi/2
	local math_pi_quarter = math.pi/4
	self.rotYstart = 4.2;
	self.transXmax = 0.6;
	self.transZmax = 0.1;
    local rotY = self.cameras[self.camIndex].rotY;
    while (rotY < -math_pi_double) do rotY = rotY + math_pi_double; end
    while (rotY >  math_pi_double) do rotY = rotY - math_pi_double; end
	if(self.cameras[self.camIndex].rotY > (4.4)) then
		self.rear = 1;
	else
		self.rear = 0;
	end;
	self.rozdilY = self.cameras[self.camIndex].rotY - self.rotYstart;
	if(math_pi_double > self.cameras[self.camIndex].rotY and self.cameras[self.camIndex].rotY > (self.rotYstart)) then
		self.camPositionX = (self.tx + (self.rozdilY * 0.5)) * 1;
		self.camPositionZ = (self.tz + (self.rozdilY * 0.5)) * 1;
		if self.camPositionX >= self.tx + self.transXmax then
			self.camPositionX = self.tx + self.transXmax;
		end;
		if self.camPositionZ >= self.tz + self.transZmax then
			self.camPositionZ = self.tz + self.transZmax;
		end;
		if self.cameras[self.camIndex].rotY >= 6 then self.cameras[self.camIndex].rotY = 6; end;
	else
		self.camPositionX = self.tx;
		self.camPositionZ = self.tz;
	end;
	if self.internalCamera ~= nil and self.cameras[self.camIndex].isInside == true then
			setTranslation(self.internalCamera, self.camPositionX, self.camPositionY, self.camPositionZ);
	end;
end;
end;

function ReversingCamera:updateTick(dt)
end;

function ReversingCamera:draw()
end;

function ReversingCamera:onLeave()
end;